#include <SD.h>
#include <LiquidCrystal_I2C.h>

#define SENSOR 9
#define BUTTON 4

File logfile;
int CS = 10;
int ratID = 1;
long time_now;
char TimeValue[] = "00:00.00";
char time_val[] = "00:00.00";
long milliseconds;
long hundredth_seconds;
uint8_t seconds;
uint8_t minutes;
LiquidCrystal_I2C lcd(0x27,16,2);

int sensorState = 0;
int buttonState = 0;

void setup() {
  pinMode(CS, OUTPUT);
  pinMode(SENSOR, INPUT);
  pinMode(BUTTON,INPUT);
  digitalWrite(SENSOR, HIGH);
  lcd.init();
  lcd.backlight();
  lcd.setCursor(4,0);

  if (SD.begin())
  {
    lcd.print("SD setup            ");
    lcd.setCursor(4,1);
    lcd.print("complete!");
    delay(2000);
  } else
  {
    lcd.print("SD setup         ");
    lcd.setCursor(4,1);
    lcd.print("failed :(");
    return;
  }

  lcd.setCursor(0,0);
  lcd.print("Creating file...      ");
  lcd.setCursor(0,1);
  lcd.print("               ");
  delay(2000);
  char filename[] = "LOGGER00.csv"; 
  for (uint8_t i = 0; i < 100; i++) {
    filename[6] = i / 10 + '0';
    filename[7] = i % 10 + '0';
    if (! SD.exists(filename)) {
      logfile = SD.open(filename, FILE_WRITE);
      logfile.println("ID,Duration,Milliseconds");
      break;
    }
  }
  if (logfile) {
    lcd.setCursor(0,0);
    lcd.print("  File ready!   ");
    lcd.setCursor(0,1);
    lcd.print("                 ");
    delay(1000);
    lcd.setCursor(0,0);
    lcd.print("   Rat ID: 1   ");
    lcd.setCursor(0,1);
    lcd.print("   00:00.00");
    lcd.setCursor(0,0);
    logfile.flush(); // save
  }
  else {
    lcd.setCursor(0,0);
    lcd.print("  Error creating    ");
    lcd.setCursor(0,1);
    lcd.print("  file :(");
  }
}

void loop() {
  if (digitalRead(4) == HIGH){
      logfile.print(ratID);
      logfile.print(",");
      logfile.print(time_val);
      logfile.print(",");
      logfile.println(milliseconds);
      logfile.flush();
      ratID = ratID + 1;
      lcd.setCursor(0,0);
      lcd.print("   Saving...   ");
      lcd.setCursor(0,1);
      lcd.print("              ");
      delay(3000);
      lcd.setCursor(0,0);
      lcd.print("   Rat ID: ");
      lcd.print(ratID);
      lcd.print("       ");
      lcd.setCursor(0,1);
      lcd.print("   00:00.00");
      time_now = 0;
      
  }
  
  sensorState = digitalRead(SENSOR);
  if (sensorState == LOW) {
    time_now = millis();
    for (uint64_t counter = 0; counter < 99999999999999999; counter++) {
      delay(10);
      milliseconds = millis()-time_now;
      hundredth_seconds = milliseconds/10;
      TimeValue[7] = (hundredth_seconds % 10 + '0');
      TimeValue[6] = (hundredth_seconds / 10 % 10 + '0');
      seconds = hundredth_seconds / 100 % 60;
      minutes = hundredth_seconds / 100 / 60;
      TimeValue[4] = seconds % 10 + '0';
      TimeValue[3] = seconds / 10 + '0';
      TimeValue[1] = minutes % 10 + '0';
      TimeValue[0] = minutes / 10 + '0';
      lcd.setCursor(0,0);
      lcd.print("   Rat ID: ");
      lcd.setCursor(11,0);
      lcd.print(ratID);
      lcd.setCursor(0,1);
      lcd.print("   ");
      lcd.print(TimeValue);
      for(int i = 0;i < 8;i++){
      time_val[i] = TimeValue[i];
      }
      
      sensorState = digitalRead(SENSOR);
      if (sensorState == HIGH){
        delay(3000);
      break;
     }
    }
  
  }
}
